Package org.apache.coyote.http11.upgrade

## Class UpgradeServletOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - javax.servlet.ServletOutputStream
    - - org.apache.coyote.http11.upgrade.UpgradeServletOutputStream

All Implemented Interfaces:
  `java.io.Closeable`, `java.io.Flushable`, `java.lang.AutoCloseable`

    public class UpgradeServletOutputStream
    extends ServletOutputStream

### Constructor Summary

Constructors
`UpgradeServletOutputStream​(UpgradeProcessorBase processor, SocketWrapperBase<?> socketWrapper, UpgradeInfo upgradeInfo)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `close()`
`void` `flush()`
`boolean` `isReady()` Checks if a non-blocking write will succeed.
`void` `setWriteListener​(WriteListener listener)` Sets the `WriteListener` for this `ServletOutputStream` and thereby switches to non-blocking IO.
`void` `write​(byte[] b, int off, int len)`
`void` `write​(int b)`

### Methods inherited from class javax.servlet.ServletOutputStream

`print, print, print, print, print, print, print, println, println, println, println, println, println, println, println`

### Methods inherited from class java.io.OutputStream

`nullOutputStream, write`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### UpgradeServletOutputStream

    public UpgradeServletOutputStream​(UpgradeProcessorBase processor,
                                      SocketWrapperBase<?> socketWrapper,
                                      UpgradeInfo upgradeInfo)

### Method Detail

#### isReady

    public final boolean isReady()

Description copied from class: `javax.servlet.ServletOutputStream`
Checks if a non-blocking write will succeed. If this returns `false`, it will cause a callback to `WriteListener.onWritePossible()` when the buffer has emptied. If this method returns `false` no further data must be written until the container calls `WriteListener.onWritePossible()`.

Specified by:
  `isReady` in class `ServletOutputStream`
Returns:
  `true` if data can be written, else `false`

#### setWriteListener

    public final void setWriteListener​(WriteListener listener)

Description copied from class: `javax.servlet.ServletOutputStream`
Sets the `WriteListener` for this `ServletOutputStream` and thereby switches to non-blocking IO. It is only valid to switch to non-blocking IO within async processing or HTTP upgrade processing.

Specified by:
  `setWriteListener` in class `ServletOutputStream`
Parameters:
  `listener` - The non-blocking IO write listener

#### write

    public void write​(int b)
               throws java.io.IOException

Specified by:
  `write` in class `java.io.OutputStream`
Throws:
  `java.io.IOException`

#### write

    public void write​(byte[] b,
                      int off,
                      int len)
               throws java.io.IOException

Overrides:
  `write` in class `java.io.OutputStream`
Throws:
  `java.io.IOException`

#### flush

    public void flush()
               throws java.io.IOException

Specified by:
  `flush` in interface `java.io.Flushable`
Overrides:
  `flush` in class `java.io.OutputStream`
Throws:
  `java.io.IOException`

#### close

    public void close()
               throws java.io.IOException

Specified by:
  `close` in interface `java.lang.AutoCloseable`
Specified by:
  `close` in interface `java.io.Closeable`
Overrides:
  `close` in class `java.io.OutputStream`
Throws:
  `java.io.IOException`